<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.parkingspace_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="residentialId" slot-scope="scope">{{scope.row.residentialName}}</template>
      <template slot="residentialIdForm" slot-scope="scope">
        <select-dialog-residential :disabled="residentialDisabled" :id="form.residentialId" :name="form.residentialName" :callback="selectCallback"></select-dialog-residential>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/estate/parkingspace";
  import {mapGetters} from "vuex";
  import SelectDialogResidential from "../../components/select-dialog/select-dialog-residential";

  export default {
    components: {SelectDialogResidential},
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        residentialDisabled: false,
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "车位编号",
              prop: "number",
              rules: [{
                required: true,
                message: "请输入车位编号",
                trigger: "blur"
              }]
            },
            {
              label: "车位类型",
              prop: "type",
              type:'select',
              dataType:'number',
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=parkinglot-type",
              props: {
                label: 'dictValue',
                value: 'dictKey'
              },
              rules: [{
                required: true,
                message: "请输入车位类型（微型，小型，中型，大型）跟车辆类型对应",
                trigger: "blur"
              }]
            },
            // {
            //   label: "占用车辆",
            //   prop: "carId",
            //   rules: [{
            //     required: true,
            //     message: "请输入占用车辆",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "是否收费",
              prop: "isFree",
              type:"select",
              value: 1,
              dicData:[
                {
                  label:'是',
                  value:0
                },{
                  label:'否',
                  value:1
                }
              ],
              rules: [{
                required: false,
                message: "请输入是否收费",
                trigger: "blur"
              }]
            },
            {
              label: "是否室内",
              prop: "isIndoor",
              type:"select",
              value: 1,
              dicData:[
                {
                  label:'是',
                  value:0
                },{
                  label:'否',
                  value:1
                }
              ],
              rules: [{
                required: false,
                message: "请输入是否室内",
                trigger: "blur"
              }],
            },
            {
              label: "所属小区",
              prop: "residentialId",
              type: "select",
              slot:true,
              formslot:true,
              // dicUrl: "/api/cyzh-community/residential/list?agencyId={{key}}&&size=9999",
              dicUrl: "/api/cyzh-community/residential/list?size=500",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              // dicFlag: false,
              filterable: true,
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: false,
                message: "请选择所属小区",
                trigger: "blur"
              }]
            },
            // {
            //   label: "机构路径",
            //   prop: "orgPosition",
            //   rules: [{
            //     required: true,
            //     message: "请输入机构路径",
            //     trigger: "blur"
            //   }]
            // },

            {
              label: "所属车场",
              prop: "parkingLotId",
              type: "select",
              search: true,
              // dicFlag: false,
              // remote: true,
              dicUrl: "/api/cyzh-estate/parkinglot/list",
              props: {
                label: 'parkName',
                value: 'id'
              },
              filterable: true,
              searchFilterable: true,
              dicFormatter: (res) => {
                return res.data.records;
              },
              rules: [{
                require: true,
                message: "请选择所属车场",
                trigger: "blur"
              }]
            },
            {
              label: "是否占用",
              prop: "isUsed",
              type: "select",
              value: 0,
              dicData: [{
                label: "已占用",
                value: 1
              },{
                label: "未占用",
                value: 0
              }],
              rules: [{
                required: false,
                message: "请输入是否占用: 1-已占用 0-未占用",
                trigger: "blur"
              }],
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.parkingspace_add, false),
          viewBtn: this.vaildData(this.permission.parkingspace_view, false),
          delBtn: this.vaildData(this.permission.parkingspace_delete, false),
          editBtn: this.vaildData(this.permission.parkingspace_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    created() {
      const tenantType = localStorage.getItem("tenantType");
      if (tenantType == 0){
        this.option.column[4].label = "所属小区"
      }else if (tenantType == 1){
        this.option.column[4].label = "所属区域"
      }
    },
    methods: {
      selectCallback(row){
        this.form.residentialId = row.id;
        this.form.residentialName = row.name;
        if (this.option.column[5].prop == 'parkingLotId' && this.option.column[5].dicUrl.indexOf('residentialId') == -1){
          this.option.column[5].dicUrl += '?residentialId=' + this.form.residentialId + '&size=100';

        }
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        this.residentialDisabled = false;
        if (["edit", "view"].includes(type)) {
          this.residentialDisabled = type == "view";
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
